Index: Makefile
===================================================================
--- Makefile	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ Makefile	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -30,8 +30,5 @@
 #
 
-CSCOPE = cscope
-STANSE = stanse
-
-.PHONY: all config config_default distclean clean cscope stanse
+.PHONY: all config config_default distclean clean cscope
 
 all: Makefile.config config.h config.defs
@@ -39,12 +36,4 @@
 	$(MAKE) -C uspace
 	$(MAKE) -C boot
-
-stanse: Makefile.config config.h config.defs
-	$(MAKE) -C kernel clean
-	$(MAKE) -C kernel EXTRA_TOOL=stanse
-	$(STANSE) --checker ReachabilityChecker --jobfile kernel/kernel.job
-
-cscope:
-	find kernel boot uspace -regex '^.*\.[chsS]$$' | xargs $(CSCOPE) -b -k -u -f$(CSCOPE).out
 
 Makefile.config: config_default
@@ -61,8 +50,13 @@
 
 distclean: clean
-	rm -f $(CSCOPE).out Makefile.config config.h config.defs tools/*.pyc
+	rm -f Makefile.config config.h config.defs tools/*.pyc
 
 clean:
-	$(MAKE) -C kernel clean
-	$(MAKE) -C uspace clean
-	$(MAKE) -C boot clean
+	-$(MAKE) -C kernel clean
+	-$(MAKE) -C uspace clean
+	-$(MAKE) -C boot clean
+
+cscope:
+	find kernel boot uspace -regex '^.*\.[chsS]$$' -print > srclist
+	rm -f cscope.out
+	cscope -bi srclist
Index: contrib/toolchain.sh
===================================================================
--- contrib/toolchain.sh	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ contrib/toolchain.sh	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -92,33 +92,10 @@
 }
 
-patch_binutils() {
-	PLATFORM="$1"
-	
-	if [ "${PLATFORM}" == "arm32" ] ; then
-		patch -p1 <<EOF
-diff -Naur binutils-2.20.orig/gas/config/tc-arm.c binutils-2.20/gas/config/tc-arm.c
---- binutils-2.20.orig/gas/config/tc-arm.c	2009-08-30 00:10:59.000000000 +0200
-+++ binutils-2.20/gas/config/tc-arm.c	2009-11-02 14:25:11.000000000 +0100
-@@ -2485,8 +2485,9 @@
-       know (frag->tc_frag_data.first_map == NULL);
-       frag->tc_frag_data.first_map = symbolP;
-     }
--  if (frag->tc_frag_data.last_map != NULL)
-+  if (frag->tc_frag_data.last_map != NULL) {
-     know (S_GET_VALUE (frag->tc_frag_data.last_map) < S_GET_VALUE (symbolP));
-+  }
-   frag->tc_frag_data.last_map = symbolP;
- }
-EOF
-		check_error $? "Error patching binutils"
-	fi
-}
-
 build_target() {
 	PLATFORM="$1"
 	TARGET="$2"
 	
-	BINUTILS_VERSION="2.20"
-	GCC_VERSION="4.4.2"
+	BINUTILS_VERSION="2.19.1"
+	GCC_VERSION="4.4.1"
 	
 	BINUTILS="binutils-${BINUTILS_VERSION}.tar.bz2"
@@ -142,8 +119,8 @@
 	
 	echo ">>> Downloading tarballs"
-	download_check "${BINUTILS_SOURCE}" "${BINUTILS}" "ee2d3e996e9a2d669808713360fa96f8"
-	download_check "${GCC_SOURCE}" "${GCC_CORE}" "d50ec5af20508974411d0c83c5f4e396"
-	download_check "${GCC_SOURCE}" "${GCC_OBJC}" "d8d26187d386a0591222a580b5a5b3d3"
-	download_check "${GCC_SOURCE}" "${GCC_CPP}" "43b1e4879eb282dc4b05e4c016d356d7"
+	download_check "${BINUTILS_SOURCE}" "${BINUTILS}" "09a8c5821a2dfdbb20665bc0bd680791"
+	download_check "${GCC_SOURCE}" "${GCC_CORE}" "d19693308aa6b2052e14c071111df59f"
+	download_check "${GCC_SOURCE}" "${GCC_OBJC}" "f7b2a606394036e81433b2f4c3251cba"
+	download_check "${GCC_SOURCE}" "${GCC_CPP}" "d449047b5761348ceec23739f5553e0b"
 	
 	echo ">>> Removing previous content"
@@ -165,5 +142,4 @@
 	cd "${BINUTILSDIR}"
 	check_error $? "Change directory failed."
-	patch_binutils "${PLATFORM}"
 	./configure "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" "--disable-nls"
 	check_error $? "Error configuring binutils."
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/Makefile	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -33,8 +33,7 @@
 all: ../version ../Makefile.config ../config.h ../config.defs
 	-[ -f $(DEPEND) ] && mv -f $(DEPEND) $(DEPEND_PREV)
-	$(MAKE) -f Makefile.build EXTRA_TOOL=$(EXTRA_TOOL)
+	$(MAKE) -f Makefile.build
 
 clean:
-	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(JOB) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* $(ARCH_INCLUDE) $(GENARCH_INCLUDE) arch/*/_link.ld
+	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* $(ARCH_INCLUDE) $(GENARCH_INCLUDE) arch/*/_link.ld
 	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o' -follow -exec rm \{\} \;
-	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o.preproc' -follow -exec rm \{\} \;
Index: kernel/Makefile.build
===================================================================
--- kernel/Makefile.build	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/Makefile.build	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -91,5 +91,5 @@
 ## Cross-platform assembly to start a symtab.data section
 #
-SYMTAB_SECTION = ".section symtab.data, \"a\", $(ATSIGN)progbits;"
+SYMTAB_SECTION=".section symtab.data, \"a\", $(ATSIGN)progbits;"
 
 ## Simple detection for the type of the host system
@@ -110,5 +110,5 @@
 ifeq ($(COMPILER),gcc_native)
 	CC = gcc
-	GCC = gcc
+	GCC = $(CC)
 	AS = $(BINUTILS_PREFIX)as
 	LD = $(BINUTILS_PREFIX)ld
@@ -168,5 +168,4 @@
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 endif
-
 
 ## Generic kernel sources
@@ -385,7 +384,4 @@
 test/fpu/%.o: test/fpu/%.c $(DEPEND)
 	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) -c $< -o $@
-ifeq ($(EXTRA_TOOL),stanse)
-	../tools/jobfile.py $(JOB) $< $@ $(DEFS) $(CFLAGS) $(EXTRA_FLAGS)
-endif
 
 #
@@ -394,7 +390,4 @@
 %.o: %.c $(DEPEND)
 	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) $(FPU_NO_CFLAGS) -c $< -o $@
-ifeq ($(EXTRA_TOOL),stanse)
-	../tools/jobfile.py $(JOB) $< $@ $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) $(FPU_NO_CFLAGS)
-endif
 
 $(REAL_MAP).o: $(REAL_MAP).bin
Index: kernel/Makefile.common
===================================================================
--- kernel/Makefile.common	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/Makefile.common	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,5 +36,4 @@
 BIN = kernel.bin
 MAP = kernel.map
-JOB = kernel.job
 MAP_PREV = $(MAP).prev
 DISASM = kernel.disasm
Index: kernel/arch/amd64/include/mm/page.h
===================================================================
--- kernel/arch/amd64/include/mm/page.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/amd64/include/mm/page.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -177,23 +177,5 @@
 #define PFERR_CODE_ID		(1 << 4)
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned present : 1;
-	unsigned writeable : 1;
-	unsigned uaccessible : 1;
-	unsigned page_write_through : 1;
-	unsigned page_cache_disable : 1;
-	unsigned accessed : 1;
-	unsigned dirty : 1;
-	unsigned unused: 1;
-	unsigned global : 1;
-	unsigned soft_valid : 1;		/**< Valid content even if present bit is cleared. */
-	unsigned avl : 2;
-	unsigned addr_12_31 : 30;
-	unsigned addr_32_51 : 21;
-	unsigned no_execute : 1;
-} __attribute__ ((packed)) pte_t;
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/amd64/include/types.h
===================================================================
--- kernel/arch/amd64/include/types.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/amd64/include/types.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -82,4 +82,22 @@
 #define PRIxn "llx"
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;
+	unsigned writeable : 1;
+	unsigned uaccessible : 1;
+	unsigned page_write_through : 1;
+	unsigned page_cache_disable : 1;
+	unsigned accessed : 1;
+	unsigned dirty : 1;
+	unsigned unused: 1;
+	unsigned global : 1;
+	unsigned soft_valid : 1;		/**< Valid content even if present bit is cleared. */
+	unsigned avl : 2;
+	unsigned addr_12_31 : 30;
+	unsigned addr_32_51 : 21;
+	unsigned no_execute : 1;
+} __attribute__ ((packed)) pte_t;
+
 #endif
 
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/amd64/src/amd64.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -67,5 +67,4 @@
 #include <ddi/irq.h>
 #include <sysinfo/sysinfo.h>
-#include <memstr.h>
 
 /** Disable I/O on non-privileged levels
Index: kernel/arch/arm32/include/atomic.h
===================================================================
--- kernel/arch/arm32/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/arm32/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -37,6 +37,4 @@
 #define KERN_arm32_ATOMIC_H_
 
-#include <arch/asm.h>
-
 /** Atomic addition.
  *
@@ -49,14 +47,19 @@
 static inline long atomic_add(atomic_t *val, int i)
 {
-	long ret;
-
-	/*
-	 * This implementation is for UP pre-ARMv6 systems where we do not have
-	 * the LDREX and STREX instructions.
-	 */
-	ipl_t ipl = interrupts_disable();
-	val->count += i;
-	ret = val->count;
-	interrupts_restore(ipl);
+	int ret;
+	volatile long *mem = &(val->count);
+	
+	asm volatile (
+		"1:\n"
+			"ldr r2, [%[mem]]\n"
+			"add r3, r2, %[i]\n"
+			"str r3, %[ret]\n"
+			"swp r3, r3, [%[mem]]\n"
+			"cmp r3, r2\n"
+			"bne 1b\n"
+		: [ret] "=m" (ret)
+		: [mem] "r" (mem), [i] "r" (i)
+		: "r3", "r2"
+	);
 	
 	return ret;
Index: kernel/arch/arm32/include/mm/page.h
===================================================================
--- kernel/arch/arm32/include/mm/page.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/arm32/include/mm/page.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -75,5 +75,5 @@
 /* Get PTE address accessors for each level. */
 #define GET_PTL1_ADDRESS_ARCH(ptl0, i) \
-	((pte_t *) ((((pte_t *)(ptl0))[(i)].l0).coarse_table_addr << 10))
+	((pte_t *) ((((pte_level0_t *)(ptl0))[(i)]).coarse_table_addr << 10))
 #define GET_PTL2_ADDRESS_ARCH(ptl1, i) \
 	(ptl1)
@@ -81,19 +81,19 @@
 	(ptl2)
 #define GET_FRAME_ADDRESS_ARCH(ptl3, i) \
-	((uintptr_t) ((((pte_t *)(ptl3))[(i)].l1).frame_base_addr << 12))
+	((uintptr_t) ((((pte_level1_t *)(ptl3))[(i)]).frame_base_addr << 12))
 
 /* Set PTE address accessors for each level. */
 #define SET_PTL0_ADDRESS_ARCH(ptl0) \
-	(set_ptl0_addr((pte_t *) (ptl0)))
+	(set_ptl0_addr((pte_level0_t *) (ptl0)))
 #define SET_PTL1_ADDRESS_ARCH(ptl0, i, a) \
-	(((pte_t *) (ptl0))[(i)].l0.coarse_table_addr = (a) >> 10)
+	(((pte_level0_t *) (ptl0))[(i)].coarse_table_addr = (a) >> 10)
 #define SET_PTL2_ADDRESS_ARCH(ptl1, i, a)
 #define SET_PTL3_ADDRESS_ARCH(ptl2, i, a)
 #define SET_FRAME_ADDRESS_ARCH(ptl3, i, a) \
-	(((pte_t *) (ptl3))[(i)].l1.frame_base_addr = (a) >> 12)
+	(((pte_level1_t *) (ptl3))[(i)].frame_base_addr = (a) >> 12)
 
 /* Get PTE flags accessors for each level. */
 #define GET_PTL1_FLAGS_ARCH(ptl0, i) \
-	get_pt_level0_flags((pte_t *) (ptl0), (size_t) (i))
+	get_pt_level0_flags((pte_level0_t *) (ptl0), (size_t) (i))
 #define GET_PTL2_FLAGS_ARCH(ptl1, i) \
 	PAGE_PRESENT
@@ -101,13 +101,13 @@
 	PAGE_PRESENT
 #define GET_FRAME_FLAGS_ARCH(ptl3, i) \
-	get_pt_level1_flags((pte_t *) (ptl3), (size_t) (i))
+	get_pt_level1_flags((pte_level1_t *) (ptl3), (size_t) (i))
 
 /* Set PTE flags accessors for each level. */
 #define SET_PTL1_FLAGS_ARCH(ptl0, i, x) \
-	set_pt_level0_flags((pte_t *) (ptl0), (size_t) (i), (x))
+	set_pt_level0_flags((pte_level0_t *) (ptl0), (size_t) (i), (x))
 #define SET_PTL2_FLAGS_ARCH(ptl1, i, x)
 #define SET_PTL3_FLAGS_ARCH(ptl2, i, x)
 #define SET_FRAME_FLAGS_ARCH(ptl3, i, x) \
-	set_pt_level1_flags((pte_t *) (ptl3), (size_t) (i), (x))
+	set_pt_level1_flags((pte_level1_t *) (ptl3), (size_t) (i), (x))
 
 /* Macros for querying the last-level PTE entries. */
@@ -115,9 +115,10 @@
 	(*((uint32_t *) (pte)) != 0)
 #define PTE_PRESENT_ARCH(pte) \
-	(((pte_t *) (pte))->l0.descriptor_type != 0)
+	(((pte_level0_t *) (pte))->descriptor_type != 0)
 #define PTE_GET_FRAME_ARCH(pte) \
-	(((pte_t *) (pte))->l1.frame_base_addr << FRAME_WIDTH)
+	(((pte_level1_t *) (pte))->frame_base_addr << FRAME_WIDTH)
 #define PTE_WRITABLE_ARCH(pte) \
-	(((pte_t *) (pte))->l1.access_permission_0 == PTE_AP_USER_RW_KERNEL_RW)
+	(((pte_level1_t *) (pte))->access_permission_0 == \
+	    PTE_AP_USER_RW_KERNEL_RW)
 #define PTE_EXECUTABLE_ARCH(pte) \
 	1
@@ -158,8 +159,4 @@
 } ATTRIBUTE_PACKED pte_level1_t;
 
-typedef union {
-	pte_level0_t l0;
-	pte_level1_t l1;
-} pte_t;
 
 /* Level 1 page tables access permissions */
@@ -194,5 +191,5 @@
  * @param pt    Pointer to the page table to set.
  */   
-static inline void set_ptl0_addr(pte_t *pt)
+static inline void set_ptl0_addr(pte_level0_t *pt)
 {
 	asm volatile (
@@ -208,7 +205,7 @@
  *  @param i      Index of the entry to return.
  */
-static inline int get_pt_level0_flags(pte_t *pt, size_t i)
-{
-	pte_level0_t *p = &pt[i].l0;
+static inline int get_pt_level0_flags(pte_level0_t *pt, size_t i)
+{
+	pte_level0_t *p = &pt[i];
 	int np = (p->descriptor_type == PTE_DESCRIPTOR_NOT_PRESENT);
 
@@ -223,7 +220,7 @@
  *  @param i      Index of the entry to return.
  */
-static inline int get_pt_level1_flags(pte_t *pt, size_t i)
-{
-	pte_level1_t *p = &pt[i].l1;
+static inline int get_pt_level1_flags(pte_level1_t *pt, size_t i)
+{
+	pte_level1_t *p = &pt[i];
 
 	int dt = p->descriptor_type;
@@ -248,7 +245,7 @@
  *  @param flags  new flags
  */
-static inline void set_pt_level0_flags(pte_t *pt, size_t i, int flags)
-{
-	pte_level0_t *p = &pt[i].l0;
+static inline void set_pt_level0_flags(pte_level0_t *pt, size_t i, int flags)
+{
+	pte_level0_t *p = &pt[i];
 
 	if (flags & PAGE_NOT_PRESENT) {
@@ -276,7 +273,7 @@
  *  @param flags  New flags.
  */  
-static inline void set_pt_level1_flags(pte_t *pt, size_t i, int flags)
-{
-	pte_level1_t *p = &pt[i].l1;
+static inline void set_pt_level1_flags(pte_level1_t *pt, size_t i, int flags)
+{
+	pte_level1_t *p = &pt[i];
 	
 	if (flags & PAGE_NOT_PRESENT) {
Index: kernel/arch/arm32/include/types.h
===================================================================
--- kernel/arch/arm32/include/types.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/arm32/include/types.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -87,4 +87,13 @@
 #define PRIxn "x"	/**< Format for hexadecimal (u)native_t. */
 
+/** Page table entry.
+ *
+ *  We have different structs for level 0 and level 1 page table entries.
+ *  See page.h for definition of pte_level*_t.
+ */
+typedef struct {
+	unsigned dummy : 32;
+} pte_t;
+
 #endif
 
Index: kernel/arch/arm32/src/mm/as.c
===================================================================
--- kernel/arch/arm32/src/mm/as.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/arm32/src/mm/as.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,5 +36,4 @@
 #include <arch/mm/as.h>
 #include <genarch/mm/as_pt.h>
-#include <genarch/mm/page_pt.h>
 #include <genarch/mm/asid_fifo.h>
 #include <mm/as.h>
Index: kernel/arch/ia32/include/mm/page.h
===================================================================
--- kernel/arch/ia32/include/mm/page.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ia32/include/mm/page.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -146,21 +146,5 @@
 #define PFERR_CODE_RSVD		(1 << 3)	
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned present : 1;
-	unsigned writeable : 1;
-	unsigned uaccessible : 1;
-	unsigned page_write_through : 1;
-	unsigned page_cache_disable : 1;
-	unsigned accessed : 1;
-	unsigned dirty : 1;
-	unsigned pat : 1;
-	unsigned global : 1;
-	unsigned soft_valid : 1;	/**< Valid content even if the present bit is not set. */
-	unsigned avl : 2;
-	unsigned frame_address : 20;
-} __attribute__ ((packed)) pte_t;
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/ia32/include/types.h
===================================================================
--- kernel/arch/ia32/include/types.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ia32/include/types.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -80,4 +80,20 @@
 #define PRIxn "x"	/**< Format for hexadecimal (u)native_t. */
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;
+	unsigned writeable : 1;
+	unsigned uaccessible : 1;
+	unsigned page_write_through : 1;
+	unsigned page_cache_disable : 1;
+	unsigned accessed : 1;
+	unsigned dirty : 1;
+	unsigned pat : 1;
+	unsigned global : 1;
+	unsigned soft_valid : 1;	/**< Valid content even if the present bit is not set. */
+	unsigned avl : 2;
+	unsigned frame_address : 20;
+} __attribute__ ((packed)) pte_t;
+
 #endif
 
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ia32/src/ia32.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -68,5 +68,4 @@
 #include <sysinfo/sysinfo.h>
 #include <arch/boot/boot.h>
-#include <memstr.h>
 
 #ifdef CONFIG_SMP
Index: kernel/arch/ia64/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia64/src/cpu/cpu.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ia64/src/cpu/cpu.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -37,5 +37,4 @@
 #include <arch/register.h>
 #include <print.h>
-#include <memstr.h>
 
 void cpu_arch_init(void)
Index: kernel/arch/mips32/include/mm/page.h
===================================================================
--- kernel/arch/mips32/include/mm/page.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/mips32/include/mm/page.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -141,19 +141,5 @@
 #include <arch/exception.h>
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned g : 1;			/**< Global bit. */
-	unsigned p : 1;			/**< Present bit. */
-	unsigned d : 1;			/**< Dirty bit. */
-	unsigned cacheable : 1;		/**< Cacheable bit. */
-	unsigned : 1;			/**< Unused. */
-	unsigned soft_valid : 1;	/**< Valid content even if not present. */
-	unsigned pfn : 24;		/**< Physical frame number. */
-	unsigned w : 1;			/**< Page writable bit. */
-	unsigned a : 1;			/**< Accessed bit. */
-} pte_t;
-
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/mips32/include/types.h
===================================================================
--- kernel/arch/mips32/include/types.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/mips32/include/types.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -80,4 +80,17 @@
 #define PRIxn "x"	/**< Format for hexadecimal (u)native_t. */
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned g : 1;			/**< Global bit. */
+	unsigned p : 1;			/**< Present bit. */
+	unsigned d : 1;			/**< Dirty bit. */
+	unsigned cacheable : 1;		/**< Cacheable bit. */
+	unsigned : 1;			/**< Unused. */
+	unsigned soft_valid : 1;	/**< Valid content even if not present. */
+	unsigned pfn : 24;		/**< Physical frame number. */
+	unsigned w : 1;			/**< Page writable bit. */
+	unsigned a : 1;			/**< Accessed bit. */
+} pte_t;
+
 #endif
 
Index: kernel/arch/ppc32/include/mm/page.h
===================================================================
--- kernel/arch/ppc32/include/mm/page.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ppc32/include/mm/page.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -131,16 +131,5 @@
 #include <arch/interrupt.h>
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned present : 1;             /**< Present bit. */
-	unsigned page_write_through : 1;  /**< Write thought caching. */
-	unsigned page_cache_disable : 1;  /**< No caching. */
-	unsigned accessed : 1;            /**< Accessed bit. */
-	unsigned global : 1;              /**< Global bit. */
-	unsigned valid : 1;               /**< Valid content even if not present. */
-	unsigned pfn : 20;                /**< Physical frame number. */
-} pte_t;
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/ppc32/include/types.h
===================================================================
--- kernel/arch/ppc32/include/types.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ppc32/include/types.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -82,4 +82,15 @@
 #define PRIxn "x"
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;             /**< Present bit. */
+	unsigned page_write_through : 1;  /**< Write thought caching. */
+	unsigned page_cache_disable : 1;  /**< No caching. */
+	unsigned accessed : 1;            /**< Accessed bit. */
+	unsigned global : 1;              /**< Global bit. */
+	unsigned valid : 1;               /**< Valid content even if not present. */
+	unsigned pfn : 20;                /**< Physical frame number. */
+} pte_t;
+
 #endif
 
Index: kernel/arch/ppc32/src/mm/as.c
===================================================================
--- kernel/arch/ppc32/src/mm/as.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ppc32/src/mm/as.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -35,5 +35,4 @@
 #include <arch/mm/as.h>
 #include <genarch/mm/as_pt.h>
-#include <genarch/mm/page_pt.h>
 #include <genarch/mm/asid_fifo.h>
 #include <arch.h>
Index: kernel/arch/ppc32/src/mm/tlb.c
===================================================================
--- kernel/arch/ppc32/src/mm/tlb.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ppc32/src/mm/tlb.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -38,5 +38,4 @@
 #include <interrupt.h>
 #include <mm/as.h>
-#include <mm/page.h>
 #include <arch.h>
 #include <print.h>
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/ppc32/src/ppc32.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -44,5 +44,4 @@
 #include <genarch/ofw/pci.h>
 #include <userspace.h>
-#include <mm/page.h>
 #include <proc/uarg.h>
 #include <console/console.h>
Index: kernel/arch/sparc64/src/mm/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/tlb.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/arch/sparc64/src/mm/tlb.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -37,5 +37,4 @@
 #include <mm/as.h>
 #include <mm/asid.h>
-#include <genarch/mm/page_ht.h>
 #include <arch/mm/frame.h>
 #include <arch/mm/page.h>
Index: kernel/genarch/include/mm/as_pt.h
===================================================================
--- kernel/genarch/include/mm/as_pt.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/genarch/include/mm/as_pt.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,5 +36,6 @@
 #define KERN_AS_PT_H_
 
-#include <arch/mm/page.h>
+#include <mm/mm.h>
+#include <arch/types.h>
 
 #define AS_PAGE_TABLE
Index: kernel/genarch/include/mm/page_pt.h
===================================================================
--- kernel/genarch/include/mm/page_pt.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/genarch/include/mm/page_pt.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -44,8 +44,7 @@
 #define KERN_PAGE_PT_H_
 
+#include <arch/types.h>
 #include <mm/as.h>
 #include <mm/page.h>
-#include <arch/mm/page.h>
-#include <arch/types.h>
 
 /*
Index: kernel/genarch/src/drivers/via-cuda/cuda.c
===================================================================
--- kernel/genarch/src/drivers/via-cuda/cuda.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/genarch/src/drivers/via-cuda/cuda.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -41,5 +41,4 @@
 #include <ddi/device.h>
 #include <synch/spinlock.h>
-#include <memstr.h>
 
 static irq_ownership_t cuda_claim(irq_t *irq);
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/genarch/src/fb/fb.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -41,5 +41,4 @@
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
-#include <mm/page.h>
 #include <mm/slab.h>
 #include <align.h>
Index: kernel/generic/include/arch.h
===================================================================
--- kernel/generic/include/arch.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/arch.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -39,5 +39,4 @@
 #include <proc/thread.h>
 #include <proc/task.h>
-#include <mm/as.h>
 
 #define DEFAULT_CONTEXT		0
Index: kernel/generic/include/context.h
===================================================================
--- kernel/generic/include/context.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/context.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -51,29 +51,17 @@
 /** Save register context.
  *
- * Save the current register context (including stack pointer) to a context
- * structure. A subsequent call to context_restore() will return to the same
+ * Save current register context (including stack pointers)
+ * to context structure.
+ *
+ * Note that call to context_restore() will return at the same
  * address as the corresponding call to context_save().
  *
- * Note that context_save_arch() must reuse the stack frame of the function
- * which called context_save(). We guarantee this by:
+ * This MUST be a macro, gcc -O0 does not inline functions even
+ * if they are marked inline and context_save_arch must be called
+ * from level <= that when context_restore is called.
  *
- *   a) implementing context_save_arch() in assembly so that it does not create
- *      its own stack frame, and by
- *   b) defining context_save() as a macro because the inline keyword is just a
- *      hint for the compiler, not a real constraint; the application of a macro
- *      will definitely not create a stack frame either.
+ * @param c Context structure.
  *
- * To imagine what could happen if there were some extra stack frames created
- * either by context_save() or context_save_arch(), we need to realize that the
- * sp saved in the contex_t structure points to the current stack frame as it
- * existed when context_save_arch() was executing. After the return from
- * context_save_arch() and context_save(), any extra stack frames created by
- * these functions will be destroyed and their contents sooner or later
- * overwritten by functions called next. Any attempt to restore to a context
- * saved like that would therefore lead to a disaster.
- *
- * @param c		Context structure.
- *
- * @return		context_save() returns 1, context_restore() returns 0.
+ * @return context_save() returns 1, context_restore() returns 0.
  */
 #define context_save(c)   context_save_arch(c)
@@ -81,12 +69,13 @@
 /** Restore register context.
  *
- * Restore a previously saved register context (including stack pointer) from
- * a context structure.
+ * Restore previously saved register context (including stack pointers)
+ * from context structure.
  *
- * Note that this function does not normally return.  Instead, it returns to the
- * same address as the corresponding call to context_save(), the only difference
- * being return value.
+ * Note that this function does not normally return.
+ * Instead, it returns at the same address as the
+ * corresponding call to context_save(), the only
+ * difference being return value.
  *
- * @param c		Context structure.
+ * @param c Context structure.
  */
 static inline void context_restore(context_t *c)
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/ipc/ipc.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -51,12 +51,14 @@
 /** This is answer to a call */
 #define IPC_CALL_ANSWERED	(1 << 0)
+/** This call will not be freed on error */
+#define IPC_CALL_STATIC_ALLOC	(1 << 1)
 /** Answer will not be passed to userspace, will be discarded */
-#define IPC_CALL_DISCARD_ANSWER (1 << 1)
+#define IPC_CALL_DISCARD_ANSWER	(1 << 2)
 /** Call was forwarded */
-#define IPC_CALL_FORWARDED	(1 << 2)
+#define IPC_CALL_FORWARDED	(1 << 3)
 /** Identify connect_me_to answer */
-#define IPC_CALL_CONN_ME_TO	(1 << 3)
+#define IPC_CALL_CONN_ME_TO	(1 << 4)
 /** Interrupt notification */
-#define IPC_CALL_NOTIF		(1 << 4)
+#define IPC_CALL_NOTIF		(1 << 5)
 
 /*
@@ -265,7 +267,4 @@
 	waitq_t wq;
 
-	/** Linkage for the list of task's synchronous answerboxes. */
-	link_t sync_box_link;
-
 	/** Phones connected to this answerbox. */
 	link_t connected_phones;
@@ -317,31 +316,25 @@
 } call_t;
 
-
-extern answerbox_t *ipc_phone_0;
-
-
 extern void ipc_init(void);
-
-extern call_t * ipc_call_alloc(int);
-extern void ipc_call_free(call_t *);
-
+extern call_t * ipc_wait_for_call(answerbox_t *, uint32_t, int);
+extern void ipc_answer(answerbox_t *, call_t *);
 extern int ipc_call(phone_t *, call_t *);
 extern int ipc_call_sync(phone_t *, call_t *);
-extern call_t * ipc_wait_for_call(answerbox_t *, uint32_t, int);
-extern int ipc_forward(call_t *, phone_t *, answerbox_t *, int);
-extern void ipc_answer(answerbox_t *, call_t *);
-
 extern void ipc_phone_init(phone_t *);
 extern void ipc_phone_connect(phone_t *, answerbox_t *);
+extern void ipc_call_free(call_t *);
+extern call_t * ipc_call_alloc(int);
+extern void ipc_answerbox_init(answerbox_t *, struct task *);
+extern void ipc_call_static_init(call_t *);
+extern void task_print_list(void);
+extern int ipc_forward(call_t *, phone_t *, answerbox_t *, int);
+extern void ipc_cleanup(void);
 extern int ipc_phone_hangup(phone_t *);
-
-extern void ipc_answerbox_init(answerbox_t *, struct task *);
-
-extern void ipc_cleanup(void);
 extern void ipc_backsend_err(phone_t *, call_t *, unative_t);
+extern void ipc_print_task(task_id_t);
 extern void ipc_answerbox_slam_phones(answerbox_t *, bool);
 extern void ipc_cleanup_call_list(link_t *);
 
-extern void ipc_print_task(task_id_t);
+extern answerbox_t *ipc_phone_0;
 
 #endif
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ kernel/generic/include/proc/task.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -55,5 +55,4 @@
 #include <udebug/udebug.h>
 #include <ipc/kbox.h>
-#include <mm/as.h>
 
 #define TASK_NAME_BUFLEN	20
@@ -99,6 +98,4 @@
 	 */
 	atomic_t active_calls;
-	/** List of synchronous answerboxes. */
-	link_t sync_box_head;
 
 #ifdef CONFIG_UDEBUG
@@ -135,5 +132,4 @@
 extern int task_kill(task_id_t id);
 extern uint64_t task_get_accounting(task_t *t);
-extern void task_print_list(void);
 
 extern void cap_set(task_t *t, cap_t caps);
